/**********************************
*
*  ڪcQOAo̥]t time_mockup_function
*  άOt  YӦmMtimeYAMw rMvar_tY
*
*
*  io̿X H(x,y,z) ܼ?
*
*
*
*
*
*
***********************************/



#macro generate_thin_composite_1_pattern_f_in_space(
first_time, last_time, d_boundary_time0, d_boundary_time1,
theta_node_amount, theta_pos_random_size, // 0 < theta_pos_random_size < 1 (valid)
min_h, max_h, d_boundary_h0, d_boundary_h1,
seed_m, h_vs_r_ratio
)


    // theta pos
    
    #local avg_theta_interval = 2*pi/theta_node_amount;
    
    #local theta_pos_array = array[theta_node_amount]
    
    #for(i, 0, theta_node_amount - 1)
        #local rand_num_a = rand(seed_m);
        #local theta_pos_array[i] = avg_theta_interval/2 + i* avg_theta_interval + theta_pos_random_size*(2*rand_num_a - 1)* avg_theta_interval/2;
    #end
    
    
    #local theta_blend_mode = 1; // cos - sin blend
    
    
    
    
    // radial bump function
    #local f_noise_apply_vs_t_impl =
    function(var_t, var_random) {
    f_noise3d(var_t, var_random, 0)
    }
    
    #local t_radial_bump_size = 0.5; // year
    
    
    
    
    
    
    
    
    
    // radial mask function
    #local radial_mask_f_mode = 0;  // 0 multiple, 1 min
    
    #local radial_spread_mask_f_array = array[theta_node_amount];
    #for(i, 0, theta_node_amount - 1)
        #local rand_num_b = rand(seed_m);
        #local rand_num_c = rand(seed_m);
        
        
        #local radial_spread_mask_f_array[i] =
        function(var_t) {
        select(
            var_t - first_time,
            0,
            select(
                var_t - (first_time + d_boundary_time0*(1 + 0.11*(2*rand_num_b - 1))),
                f_parbl_step_rise(var_t, first_time, first_time + d_boundary_time0*(1 + 0.11*(2*rand_num_b - 1))),
                select(
                    var_t - (last_time - d_boundary_time1*(1 + 0.16*(2*rand_num_c - 1))),
                    1,
                    select(
                        var_t - last_time,
                        f_parbl_step_fall(var_t, last_time - d_boundary_time1*(1 + 0.16*(2*rand_num_c - 1)), last_time),
                        0
                    )
                    
                )
            
            )
        )
        }
    #end
    
    
    
    
    // h bump function
    #local f_noise_apply_vs_h_impl =
    function(h, var_random) {
    f_bumps(h, var_random, 100)
    }
    
    
    #local h_direct_bump_size = 0.01;
    
    // h mask function
    #local h_mask_f_mode = 0; // 0 multiple, 1 min
    
    
    
    #local h_mask_f =
    function(h) {
    select(
        h - min_h,
        0,
        select(
            h - (min_h + d_boundary_h0),
            f_parbl_step_rise(h, min_h, min_h + d_boundary_h0),
            select(
                h - (max_h - d_boundary_h1),
                1,
                select(
                    h - max_h,
                    f_parbl_step_fall(h, max_h - d_boundary_h1, max_h),
                    0
                )
                
            )
        
        )
    )
    }
    
    
    
    
    #local seed_m1 = seed(rand(seed_m)*100);
    #local theta_more_thin = no;
    
    
    
    
    #local output_f = generate_thin_pattern_f_by_theta_chop_internal(
    f_noise_apply_vs_t_impl, theta_blend_mode, f_noise_apply_vs_h_impl,
    t_radial_bump_size, theta_pos_array, h_direct_bump_size,
    radial_spread_mask_f_array, h_mask_f,
    radial_mask_f_mode, h_mask_f_mode,
    seed_m1, theta_more_thin,
    min_h, max_h, h_vs_r_ratio
    );



    output_f






#end

















